<?php
// Sécurité : ne doit pas être exécuté s'il n'est pas lancé par un script autorisé
if ( !defined('OK') )  exit();

// Ce fichier est la page d'accueil de l'interface d'administration. Il ne peut
//  être lancé que par index.php, si aucun argument n'est fourni. On est donc
//  déjà passé par debut.php et la connexion MySQL est déjà ouverte.

//////////////
//// HTML ////
//////////////
// Haut de page, menu et message
$p = 'accueil_admin';
$t = 'Cahier de Prépa - Administration';
$mysqli = new mysqli($serveur,$base,$mdp,$base);
$mysqli->set_charset('utf8');
include('haut.php');

// Taille maximale de fichier
$taille = min(ini_get('upload_max_filesize'),ini_get('post_max_size'));
if ( stristr($taille,'m') )
  $taille = substr($taille,0,-1)*1048576;
elseif ( stristr($taille,'k') )
  $taille = substr($taille,0,-1)*1024;
$taille = ( $taille < 1048576 ) ? intval($taille/1024).'&nbsp;ko.' : intval($taille/1048576).'&nbsp;Mo';
?>

  <div>
    <p>Bienvenue sur l'interface d'administration de Cahier de Prépa.</p>
    <p>Cette page propose des possibilités de modifications rapide, mais vous pouvez gérer beaucoup plus de choses grâce aux liens du menu&nbsp;!</p>
  </div>

  <div class="item aide">
    <h3>Aide et explications</h3>
    <p>Vous pouvez ci-dessous effctuer les tâches quotidiennes les plus fréquentes&nbsp;: ajouter un programme de colle dans les matières qui vous sont associées, déposer un document dans n'importe quel répertoire du site, ou enregistrer une nouvelle information. Tous ces formulaires sont des raccourcis vers les différentes section de cette interface d'administration.</p>
    <h4>Programmes de colles</h4>
    <p>La case à cocher <em>Ne pas diffuser sur la partie publique</em> permet de cacher temporairement ce programme de colle, par exemple pour le diffuser ultérieurement.</p>
    <h4>Document</h4>
    <p>Le <em>nom à afficher</em> sera le nom réellement affiché sur le site web (sans extension&nbsp;: elle est détectée automatiquement lors de l'envoi). Si vous laissez cette case vide, le nom du fichier envoyé sera récupéré.</p>
    <p>Vous pouvez choisir la visibilité du document parmi trois possibilités&nbsp;:</p>
    <ul>
      <li><em>Visible de tous</em>&nbsp;: document accessible de tout visiteur</li>
      <li><em>Visible après identification</em>&nbsp; document accessible uniquement après identification, par exemple pour que seuls vos élèves les voient. Il faut alors <a href="utilisateurs">créer un utilisateur de type élève</a>.</li>
      <li><em>Non visible</em>&nbsp;: le document n'est pas encore visible en ligne. Cela peut être utile si vous souhaitez le mettre à disposition ultérieurement. C'est complètement sûr&nbsp;: vous pouvez mettre comme cela le prochain sujet de devoir ou même le corrigé.</li>
    </ul>
    <p>La taille du fichier envoyé est limitée à <?php echo $taille; ?>. Tout document est modifiable et déplaçable, sans que cela ne modifie le lien vers le document.</p>
    <h4>Information</h4>
    <p>La case à cocher <em>Ne pas diffuser sur la partie publique</em> permet de cacher temporairement cette information, par exemple pour la diffuser ultérieurement.</p>
  </div>
<?php

///////////////////////////////////
// Nouveaux programmes de colles //
///////////////////////////////////

// Fonction d'affichage des semaines
function format_date($date)  {
  $semaine = array('dimanche','lundi','mardi','mercredi','jeudi','vendredi','samedi');
  $mois = array('','janvier','février','mars','avril','mai','juin','juillet','août','septembre','octobre','novembre','décembre');
  return $semaine[substr($date,0,1)].' '.substr($date,7).' '.$mois[intval(substr($date,5,2))].' '.substr($date,1,4);
}

// Pour chaque matière
foreach ( $matieres as $m )  {
  // Récupération des semaines
  $resultat = $mysqli->query("SELECT s.id AS sid, DATE_FORMAT(s.debut,'%w%Y%m%e') AS d, s.colle, s.vacances, c.id AS cid, c.cache
                              FROM semaines AS s
                              LEFT JOIN (SELECT id, semaine, cache FROM colles WHERE matiere = ${m['id']}) AS c ON c.semaine=s.id");
  $select_semaines = '';
  if ( $resultat->num_rows )  {
    while ( $r = $resultat->fetch_assoc() )  {
      switch ( $r['vacances'] )  {
        case 0:
          if ( $r['colle'] )  {
            if ( is_null($r['cid']) )
              $select_semaines .= "\n        <option value=\"${r['sid']}\">".format_date($r['d']).'</option>';
            elseif ( $r['cache'] )
              $select_semaines .= "\n        <option value=\"${r['sid']}\" disabled>".format_date($r['d']).' (non diffusé)</option>';
            else
              $select_semaines .= "\n        <option value=\"${r['sid']}\" disabled>".format_date($r['d']).' (déjà rempli)</option>';
          }
          else
            $select_semaines .= "\n        <option value=\"${r['sid']}\" disabled>".format_date($r['d']).' (pas de colle)</option>';
          break;
        case 1:
          $select_semaines .= "\n        <option value=\"${r['sid']}\" disabled>Vacances de Toussaint</option>";
          break;
        case 2:
          $select_semaines .= "\n        <option value=\"${r['sid']}\" disabled>Vacances de Noël</option>";
          break;
        case 3:
          $select_semaines .= "\n        <option value=\"${r['sid']}\" disabled>Vacances d'hiver</option>";
          break;
        case 4:
          $select_semaines .= "\n        <option value=\"${r['sid']}\" disabled>Vacances de Pâques</option>";
      }
    }
    $resultat->free();
?>

  <div class="item admin">
  <form action="colles?<?php echo "${m['cle']}$urladmin"; ?>" method="post">
    <input class="bouton" type="submit" name="modifie" value="Valider" title="Valider les modifications">
    <h3>Enregistrer un programme de colles de <?php echo $m['nom']; ?></h3>
    <p class="ligne"><label for="id<?php echo $m['id']; ?>">Semaine&nbsp;: </label>
      <select id="id<?php echo $m['id']; ?>" name="id"><?php echo $select_semaines; ?>

      </select>
    </p>
    <textarea name="texte" rows="10" cols="100"></textarea>
    <p class="ligne"><label for="cache<?php echo $m['id']; ?>">Ne pas diffuser sur la partie publique&nbsp;: </label><input type="checkbox" id="cache<?php echo $m['id']; ?>" name="cache" value="1"></p>
  </form>
  </div>
<?php
  }
}

///////////////////////
// Envoi de document //
///////////////////////
// Récupération des répertoires, dans le bon ordre pour un select
function liste($rid,$n)  {
  $resultat = $GLOBALS['mysqli']->query("SELECT id, nom, parents FROM reps WHERE parent = $rid");
  while ( $r = $resultat->fetch_assoc() )  {
    $GLOBALS['select_reps'] .= "        <option value=\"${r['id']}\">".str_repeat('&rarr;',$n)."${r['nom']}</option>\n";
    liste($r['id'],$n+1);
  }
  $resultat->free();
}
$select_reps = '';
liste(0,0);
// Sélection automatique du répertoire racine de la matière
$resultat = $mysqli->query("SELECT id FROM reps WHERE matiere = {$matieres[0]['id']} AND parent = 0");
$r = $resultat->fetch_assoc();
$resultat->free();
$select_reps = str_replace("\"${r['id']}\"","\"${r['id']}\" selected",$select_reps);
// Choix par défaut de la protection
$select_protection = str_replace("\"${_SESSION['protection']}\"","\"${_SESSION['protection']}\" selected",'<option value="0">Visible de tous</option><option value="1">Visible après identification</option>');
?>

  <div class="item admin">
  <form action="docs<?php echo str_replace('&amp;','?',$urladmin); ?>" method="post" enctype="multipart/form-data">
    <input class="bouton" type="submit" name="envoie" value="Envoyer">
    <h3>Déposer un document</h3>
    <p class="ligne"><label for="nom">Nom à afficher&nbsp;: </label><input type="text" id="nom" name="nom" value="" size="50"></p>
    <p class="ligne"><label for="fichier">Fichier&nbsp;: </label><input type="file" id="fichier" name="fichier"></p>
    <p class="ligne"><label for="rep">Répertoire&nbsp;: </label>
      <select id="rep" name="rep">
<?php echo $select_reps; ?>
      </select>
    </p>
    <p class="ligne"><label for="protection">Accès&nbsp;: </label>
      <select id="protection" name="protection"><?php echo $select_protection; ?><option value="2">Non visible</option></select>
    </p>
    <input type="hidden" name="id" value="0">
  </form>
  </div>
<?php

//////////////////////////
// Nouvelle information //
//////////////////////////
$resultat = $mysqli->query('SELECT cle, nom FROM pages');
$select_pages = '';
while ( $r = $resultat->fetch_assoc() )
  $select_pages .= "        <option value=\"${r['cle']}\">${r['nom']}</option>\n";
$resultat->free();
?>

  <div class="item admin">
  <form action=".<?php echo str_replace('&amp;','?',$urladmin); ?>" method="post">
    <input class="bouton" type="submit" name="modifie" value="Valider" title="Valider les modifications sur le titre ou le texte">
    <h3>Enregistrer une nouvelle information</h3>
    <p class="ligne"><label for="page">Page&nbsp;: </label>
      <select id="page" name="page">
<?php echo $select_pages; ?>
      </select>
    </p>
    <input class="ligne" type="text" name="titre" size=50 maxlength=65533 value="Titre">
    <textarea name="texte" rows="6" cols="100"><p>Texte</p></textarea>
    <p class="ligne"><label for="cache">Ne pas diffuser sur la partie publique&nbsp;: </label><input type="checkbox" id="cache" name="cache" value="1"></p>
    <input type="hidden" name="id" value="0">
  </form>
  </div>

  <script type="text/javascript" src="textarea.js.php"></script>

<?php
$mysqli->close();
// Bas de page
include('bas.php');
exit();
?>
