<?php
// Sécurité : ne doit pas être exécuté s'il n'est pas lancé par un script autorisé
if ( !defined('OK') )  exit();

// La connexion MySQL (lien $mysqli) doit être obligatoirement établie par le script appelant.
// $t et $p doivent être réglés par le script appelant
// $t = titre de la page, $p = cle de la page
?><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
  <title><?php echo $t; ?></title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <link rel="stylesheet" href="css/style.css?v=4" type="text/css" media="screen">
  <link rel="stylesheet" href="css/print.css" type="text/css" media="print">
  <link rel="stylesheet" href="css/couleurs.css?v=3" type="text/css" media="screen">
  <script type="text/javascript" src="js/jquery.js"></script>
  <script type="text/javascript" src="/MathJax/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
<?php
if ( $admin )
echo <<< FIN
  <link rel="stylesheet" href="js/jquery.datepick.css" type="text/css">
  <link rel="stylesheet" href="js/jquery.timeentry.css" type="text/css">
  <script type="text/javascript" src="js/jquery.datepick.js"></script>
  <script type="text/javascript" src="js/jquery.datepick-fr.js"></script>
  <script type="text/javascript" src="js/jquery.timeentry.js"></script>
  <script type="text/javascript" src="js/jquery.timeentry-fr.js"></script>
  <script type="text/javascript" src="js/timeout.js"></script>

FIN;
?>
  <script type="text/x-mathjax-config">
    MathJax.Hub.Config({tex2jax: {inlineMath: [["$","$"],["\\(","\\)"]]}});
  </script>
</head>
<body>
<div id="global">

<h1><?php echo $t; ?></h1>

<div id="colonne">

  <div id="menu">
<?php
// Menu de l'interface d'administration et bouton de déconnexion
// Rappel : $p doit être déjà définie (clé correspondant à la page)
if ( $admin )  {
  
  // Début : déconnexion, accueil, documents toutes matières
  $actuel = array();
  $actuel['accueil'] = ( $p == 'accueil_admin' ) ? ' id="actuel"' : '';
  $actuel['prefs'] = ( $p == 'prefs' ) ? ' id="actuel"' : '';
  $lien = str_replace('&amp;','?',$urladmin);
  $actuel['docs'] = ( $p == 'docs' ) ? ' id="actuel"' : '';
  echo <<<FIN
    <div>
      <form id="deconnexion" action="" method="post"><input type="submit" name="deconnexion" value="Se déconnecter"></form>
      <a${actuel['accueil']} href=".$lien">Accueil</a>
      <a${actuel['prefs']} href="prefs$lien">Préférences</a>
      <a${actuel['docs']} href="docs$lien">Documents (toutes matières)</a>
    </div>

FIN;

  // Matières à afficher dans le menu
  $resultat = $mysqli->query("SELECT id, cle, nom, colles, cdt FROM matieres WHERE FIND_IN_SET(id,'${_SESSION['matieres']}') ORDER BY FIND_IN_SET(id,'${_SESSION['matieres']}')");
  $matieres = array();
  while ( $r = $resultat->fetch_assoc() )  {
    // Stockage utilisé dans admin.php, prefs.php
    $matieres[] = $r;
    // Pour le menu
    $actuel['colles'] = ( $p == "colles?${r['cle']}" ) ? ' id="actuel"' : '';
    $actuel['cdt'] = ( $p == "cdt?${r['cle']}" ) ? ' id="actuel"' : '';
    $actuel['docs'] = ( $p == "docs?${r['cle']}" ) ? ' id="actuel"' : '';
    echo <<<FIN
    <div>
      <h3>Matière <em>${r['nom']}</em></h3>
      <a${actuel['colles']} href="colles?${r['cle']}$urladmin">Programme de colles</a>
      <a${actuel['cdt']} href="cdt?${r['cle']}$urladmin">Cahier de texte</a>
      <a${actuel['docs']} href="docs?${r['cle']}$urladmin">Documents</a>
    </div>

FIN;
  }
  $resultat->free();

  // Pages d'informations
  $resultat = $mysqli->query('SELECT cle, nom FROM pages');
  $aff = '';
  while ( $r = $resultat->fetch_assoc() )
    $aff .= "\n      <a ".( ( $p == $r['cle'] ) ? 'id="actuel" ' : '' )."href=\".?${r['cle']}$urladmin\">${r['nom']}</a>";
  $resultat->free();
  echo <<<FIN
    <div>
      <h3>Pages d'informations</h3>$aff
    </div>

FIN;
  
  // Paramètres du site
  $aff = '';
  $liens = array(
    "utilisateurs" => "Les utilisateurs",
    "matieres" => "Les matières",
    "pages" => "Les pages du site",
    "semaines" => "Les semaines du planning annuel");
  foreach ( $liens as $a => $l )
    $aff .= "\n      <a ".( ( $p == $a ) ? 'id="actuel" ' : '' )."href=\"$a\">$l</a>";
  echo <<<FIN
    <div>
      <h3>Paramètres du site</h3>$aff
    </div>
    <div>
      <a href="http://$site/">Voir le site public (pensez à revenir vous déconnecter...)</a>
    </div>
FIN;

}
else  {
  // Menu de la partie publique : pages d'informations, page de
  // téléchargement des documents, pages des programmes de colles/cahiers
  // de texte/téléchargement pour chaque matière.
  // Rappel : $p doit être déjà définie (clé correspondant à la page)

  // Récupération et affichage des pages
  $resultat = $mysqli->query('SELECT cle, nom FROM pages');
  $aff = '';
  while ( $r = $resultat->fetch_assoc() )
    $aff .= "\n      <a ".( ( $p == $r['cle'] ) ? 'id="actuel" ' : '' )."href=\".?${r['cle']}\">${r['nom']}</a>";
  $resultat->free();
  // Page de téléchargement
  $aff .= "\n      <a ".( ( $p == 'docs' ) ? 'id="actuel" ' : '' )."href=\"docs\">Documents à télécharger</a>";
  echo <<<FIN
    <div>$aff
    </div>

FIN;

  // Récupération et affichage des matières
  $resultat = $mysqli->query('SELECT cle, nom, MOD(colles,2) AS colles, MOD(cdt,2) AS cdt, docs
                              FROM matieres WHERE MOD(colles,2)+MOD(cdt,2)+docs');
  if ( $resultat->num_rows )  {
    while ( $r = $resultat->fetch_assoc() )  {
      $aff = '';
      if ( $r['colles'] )
        $aff .= "\n      <a ".( ( $p == "colles?${r['cle']}" ) ? 'id="actuel" ' : '' )."href=\"colles?${r['cle']}\">Programme de colles</a>";
      if ( $r['cdt'] )
        $aff .= "\n      <a ".( ( $p == "cdt?${r['cle']}" ) ? 'id="actuel" ' : '' )."href=\"cdt?${r['cle']}\">Cahier de texte</a>";
      if ( $r['docs'] )
        $aff .= "\n      <a ".( ( $p == "docs?${r['cle']}" ) ? 'id="actuel" ' : '' )."href=\"docs?${r['cle']}\">Documents à télécharger</a>";
      echo <<<FIN
    <div>
      <h3>${r['nom']}</h3>$aff
    </div>

FIN;
    }
    $resultat->free();
  }
  
  // Lien vers l'interface d'administration
  $proto = ( $https ) ? 'https://' : 'http://';
  echo "    <div>\n      <a href=\"".( ( strlen($siteadmin) ) ? $proto.$siteadmin : "$proto$site/?admin" )."\">Administration du site</a>\n    </div>";
}
?>

  </div>

<?php
// Affichage des informations récentes : seulement sur la partie publique
if ( !$admin )  {
  $resultat = $mysqli->query('SELECT titre, lien FROM recents WHERE DATEDIFF(NOW(),heure) < 10 LIMIT 20');
  if ( $resultat->num_rows )  {
    $aff = '';
    while ( $r = $resultat->fetch_assoc() )
      $aff .= "\n    <a href=\"${r['lien']}\">${r['titre']}</a>";
    $resultat->free();
    echo <<<FIN
  <div id="recent">
    <h3>Informations récentes&nbsp;<a href="rss" id="rss"><img src="icones/rss.png" alt="Flux RSS"></a></h3>$aff
  </div>


FIN;
  }
}
?>
</div>

<div id="contenu">
<?php
// Conditionnement du message éventuel
if ( isset($message) )
  echo "\n  <div class=\"warning\">$message</div>\n";
?>
