<?php
// Sécurité et récupération des données de configuration
// Mode admin obligatoire (OK=2)
define('OK',2);
include('debut.php');

///////////////////
// Modifications //
///////////////////
if ( isset($_REQUEST['modifie']) )  {
  // Connexion à la base de données
  $mysqli = new mysqli($serveur,"$base-adm",$mdp,$base);
  $mysqli->set_charset('utf8');

  // Traitement de la modification du nom d'utilisateur
  if ( isset($_REQUEST['modifie_nom']) )  {
    // Vérification des données envoyées
    if ( $_SESSION['mdp'] != SHA1($mysqli->real_escape_string($_REQUEST['mdp'])) )
      $message = 'Votre identifiant n\'a pas pu être modifié&nbsp;: le mot de passe renseigné est incorrect.';
    elseif ( !strlen($nom = $mysqli->real_escape_string($_REQUEST['nom'])) )
      $message = 'Votre identifiant n\'a pas pu être modifié&nbsp;: il ne peut pas être vide.';
    else  {
      // Sauvegarde de la table contenant les données
      sauvegarde_mysql('utilisateurs');
      $message = ( $mysqli->query("UPDATE utilisateurs SET nom = '$nom' WHERE id = ${_SESSION['id']}") ) ? 'Votre identifiant a bien été modifié.' : 'Votre identifiant n\'a pas pu être modifié. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
      $_SESSION['nom'] = $nom;
    }
  }

  // Traitement de la modification du mot de passe
  elseif ( isset($_REQUEST['modifie_mdp']) )  {
    // Vérification des données envoyées
    if ( $_SESSION['mdp'] != SHA1($mysqli->real_escape_string($_REQUEST['mdp0'])) )
      $message = 'Votre mot de passe n\'a pas pu être modifié&nbsp;: le mot de passe actuel est incorrect.';
    elseif ( !strlen($mdp1 = $mysqli->real_escape_string($_REQUEST['mdp1'])) )
      $message = 'Votre mot de passe n\'a pas pu être modifié&nbsp;: il ne peut pas être vide.';
    elseif ( $_REQUEST['mdp1'] != $_REQUEST['mdp2'] )
      $message = 'Votre mot de passe n\'a pas pu être modifié&nbsp;: vous avez tapé deux mots de passe différents.';
    else  {
      // Sauvegarde de la table contenant les données
      sauvegarde_mysql('utilisateurs');
      $message = ( $mysqli->query("UPDATE utilisateurs SET mdp = SHA1('$mdp1') WHERE id = ${_SESSION['id']}") ) ? 'Votre mot de passe a bien été modifié.' : 'Votre mot de passe n\'a pas pu être modifié. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
      $_SESSION['mdp'] = SHA1($mdp1);
    }
  }

  // Traitement de la modification des matières
  elseif ( isset($_REQUEST['modifie_matieres']) )  {
    // Validation des données envoyées
    $m = array_filter(array_unique($_REQUEST['matieres'],SORT_NUMERIC),'is_numeric');
    if ( empty($m) )
      $message = 'Vos matières associées n\'ont pas été modifiées&nbsp;: vous devez avoir au moins une matière associée.';
    else
      // Sauvegarde de la table contenant les données
      sauvegarde_mysql('utilisateurs');
      $m = implode(',',$m);
      $message = ( $mysqli->query("UPDATE utilisateurs SET matieres = '$m' WHERE id = ${_SESSION['id']}") ) ? 'Vos matières associées ont bien été modifiées.' : 'Vos matières associées n\'ont pas pu être modifiées. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
      $_SESSION['matieres'] = $m;
  }

  // Traitement de la modification de protection par défaut des documents
  elseif ( isset($_REQUEST['modifie_protection']) )  {
    // Validation des données envoyées
    $protection = ( isset($_REQUEST['protection']) ) ? 1 : 0;
    // Sauvegarde de la table contenant les données
    sauvegarde_mysql('utilisateurs');
    $message = ( $mysqli->query("UPDATE utilisateurs SET protection = $protection WHERE id = ${_SESSION['id']}") ) ? 'Votre choix par défaut de protection des documents a bien été modifié.' : 'Votre choix par défaut de protection des documents n\'a pas pu être modifié. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
    $_SESSION['protection'] = $protection;
  }

  // Traitement de la modification d'une matière
  elseif ( isset($_REQUEST['modifie_matiere']) && is_numeric($id = $_REQUEST['id']) )  {
    // Vérification des données envoyées
    if ( !strlen($_REQUEST['cle']) || !strlen($_REQUEST['nom']) )
      $message = 'Il n\'est pas possible de valider une matière sans clé ou sans nom.';
    else  {
      // Validation des données envoyées
      $cle = $mysqli->real_escape_string($_REQUEST['cle']);
      $nom = $mysqli->real_escape_string($_REQUEST['nom']);
      $colles = ", colles = IF((SELECT id FROM colles WHERE matiere = $id AND cache = 0 LIMIT 1),".( ( isset($_REQUEST['colles']) ) ? '3,2)' : '1,0)');
      $cdt = ", cdt = IF((SELECT id FROM cdt WHERE matiere = $id AND cache = 0 LIMIT 1),".( ( isset($_REQUEST['cdt']) ) ? '3,2)' : '1,0)');
      // Sauvegarde des tables contenant les données
      sauvegarde_mysql('matieres');
      sauvegarde_mysql('reps');
      $message = ( $mysqli->query("UPDATE matieres SET cle = '$cle', nom = '$nom'$colles$cdt WHERE id = $id")
                && $mysqli->query("UPDATE reps SET nom = '$nom' WHERE matiere = $id AND parent = 0")
      ) ? 'La matière <em>'.stripslashes($nom).'</em> a bien été modifiée.' : 'La matière <em>'.stripslashes($nom).'</em> n\'a pas pu être modifiée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
    }
  }
  $mysqli->close();
}

//////////////
//// HTML ////
//////////////
// Haut de page, menu et message
$p = 'prefs';
$t = 'Préférences';
$mysqli = new mysqli($serveur,$base,$mdp,$base);
$mysqli->set_charset('utf8');
include('haut.php');

/////////////////
// Identifiant //
/////////////////
?>

  <div class="item aide">
    <h3>Aide et explications</h3>
    <p>Vous pouvez ci-dessous modifier les réglages qui vous concernent personnellement&nbsp;: votre identifiant et votre mot de passe, les matières apparaissant dans le menu à gauche, le choix par défaut de la protection des documents, ainsi que les réglages de chaque matière précédemment choisies.</p>
    <h4>Identifiant</h4>
    <p>Vous pouvez changer d'identifiant. Celui-ci ne sert que pour vous connecter, il n'est pas accessible aux élèves. Les accents ne posent pas de problème. Vous devez renseigner votre mot de passe pour valider cette modification.</p>
    <h4>Mot de passe</h4>
    <p>Vous pouvez modifier votre mot de passe. Il faut bien entendu renseigner le mot de passe actuel et taper deux fois le nouveau mot de passe pour éviter les erreurs de frappe.</p>
    <p>Les mots de passe sont chiffrés avant d'être stockés dans la base de données&nbsp;: il n'y a donc aucun souci sur leur confidentialité. Même l'administrateur du site, l'hébergeur ou d'éventuels pirates ne pourront jamais y avoir accès. Lors de la connexion, le mot de passe entré est chiffré à son tour et ce sont les deux chiffrements qui sont comparés. Attention&nbsp;: il est très dangereux que ce mot de passe soit évident. Un bon mot de passe est un mot de passe d'au moins 8 caractères contenant des lettres, des chiffres et au moins un symbole parmi «&nbsp;?&nbsp;;&nbsp;:&nbsp;!&nbsp;.&nbsp;,-&nbsp;_&nbsp;». Mais vous faîtes ce que vous voulez...</p>
    <h4>Les matières vous concernant</h4>
    <p>Vous pouvez choisir quelles matières apparaissent dans le menu de gauche. Ce choix ne modifie pas les matières apparaissant dans le menu de la partie publique, ni leur ordre d'apparition. Plusieurs collègues peuvent afficher la même matière (et donc y ajouter du contenu).</p>
    <h4>Protection par défaut des documents</h4>
    <p>Pour chaque document, vous pouvez spécifier s'il est nécessaire au visiteur de s'identifier pour le voir (accès restreint aux élèves, <a href="utilisateurs">compte à créer ici</a>) ou non. Ce choix vous permet simplement de pré-cocher la case si vous le souhaiter. Vous pourrez bien sûr, pour chaque document, restreindre ou non l'accès lors de l'envoi.</p>
    <h4>Préférences de matière</h4>
    <p>Pour chaque matière vous concernant (choix fait juste au-dessus), vous pouvez modifier le <em>nom complet</em>, qui s'affiche dans le menu et dans les titres des pages.</p>
    <p>Vous pouvez aussi modifier la <em>clé dans l'adresse</em>, qui est un mot-clé utilisé uniquement dans l'adresse des pages associées à la matière. Il vaut mieux que ce soit un mot unique, court et sans majuscule. Par exemple, «&nbsp;maths&nbsp;», «&nbsp;phys&nbsp;»...</p>
    <p>Les deux cases à cocher <em>Demande d'identification pour l'affichage...</em> permettent de restreindre la visibilité du programme de colles ou du cahier de texte aux visiteurs qui se sont identifiés. Dans ce cas, après <a href="utilisateurs">avoir créé un compte pour les élèves ici</a>, ces informations seront accessibles aux élèves auxquels vous aurez donné l'identifiant et le mot de passe choisis.</p>
    <p>Les liens vers le cahier de texte, les programmes de colles et les documents sont affichés automatiquement dans le menu de la partie publique, uniquement lorsqu'il y a derrière quelque chose à afficher.</p>
  </div>

  <div class="item admin">
  <form action="" method="post">
    <input class="bouton" type="submit" name="modifie_nom" value="Valider" title="Valider les modifications">
    <h3>Modifier mon identifiant</h3>
    <p class="ligne"><label for="nom">Identifiant&nbsp;: </label><input type="text" id="nom" name="nom" value="<?php echo $_SESSION['nom']; ?>"></p>
    <p class="ligne"><label for="mdp">Mot de passe&nbsp;: </label><input type="password" id="mdp" name="mdp" value=""></p>
    <input type="hidden" name="modifie" value="">
  </form>
  </div>
<?php

//////////////////
// Mot de passe //
//////////////////
?>

  <div class="item admin">
  <form action="" method="post">
    <input class="bouton" type="submit" name="modifie_mdp" value="Valider" title="Valider les modifications">
    <h3>Modifier mon mot de passe</h3>
    <p class="ligne"><label for="mdp0">Mot de passe actuel&nbsp;: </label><input type="password" id="mdp0" name="mdp0" value=""></p>
    <p class="ligne"><label for="mdp1">Nouveau&nbsp;: </label><input type="password" id="mdp1" name="mdp1" value=""></p>
    <p class="ligne"><label for="mdp2">Confirmation&nbsp;: </label><input type="password" id="mdp2" name="mdp2" value=""></p>
    <input type="hidden" name="modifie" value="">
  </form>
  </div>
<?php

///////////////////////////////////////////
// Détermination des matières concernées //
///////////////////////////////////////////
// Récupération de toutes les matières
$resultat = $mysqli->query("SELECT id, nom, ordre FROM matieres ORDER BY ordre");
$select = "    <p id=\"ligneXX\" class=\"ligne\">Matière n°XX&nbsp;:\n      <select name=matieres[XX]>\n";
$max = $resultat->num_rows;
while ( $r = $resultat->fetch_assoc() )
  $select .= "        <option value=\"${r['id']}\">${r['nom']}</option>\n";
$resultat->free();
$select .= "      </select>\n    </p>\n";
?>

  <div class="item admin">
  <form action="" method="post">
    <input class="bouton" type="submit" name="modifie_matieres" value="Valider" title="Valider les modifications">
    <h3>Modifier mes matières</h3>
<?php
$n = 1;
foreach ( $matieres as $m )
  echo str_replace("\"${m['id']}\"","\"${m['id']}\" selected",str_replace('XX',$n++,$select));
?>
    <p class="boutons">
      <input type="button" id="ajouter" value="Ajouter une matière">
      <input type="button" id="retirer" value="Retirer la dernière matière">
    </p>
    <input type="hidden" name="modifie" value="">
  </form>
  </div>
<?php

//////////////////////////////////////////////////
// Choix de protection par défaut des documents //
//////////////////////////////////////////////////
$protection = ( $_SESSION['protection'] ) ? ' checked' : '';
?>

  <div class="item admin">
  <form action="" method="post">
    <input class="bouton" type="submit" name="modifie_protection" value="Valider" title="Valider les modifications">
    <h3>Modifier la protection par défaut de mes documents</h3>
    <p class="ligne"><label for="protection">Cocher automatiquement la case de protection pour les nouveaux documents&nbsp;: </label><input type="checkbox" id="protection" name="protection" value="1"<?php echo $protection; ?>></p>
    <input type="hidden" name="modifie" value="">
  </form>
  </div>
<?php

/////////////////////////////////////////
// Préférences des matières concernées //
/////////////////////////////////////////
foreach ( $matieres as $m )  {
  $colles = ( $m['colles'] > 1 ) ? ' checked': '';
  $cdt = ( $m['cdt'] > 1 ) ? ' checked': '';
  $id = $m['id'];
  echo <<<FIN

  <div class="item admin">
  <form action="" method="post">
    <input class="bouton" type="submit" name="modifie_matiere" value="Valider" title="Valider les modifications">
    <h3>Modifier la matière <em>${m['nom']}</em></h3>
    <p class="ligne"><label for="nom$id">Nom complet&nbsp;: </label><input type="text" id="nom$id" name="nom" value="${m['nom']}" size="50"></p>
    <p class="ligne"><label for="cle$id">Clé dans l'adresse&nbsp;: </label><input type="text" id="cle$id" name="cle" value="${m['cle']}" size="30"></p>
    <p class="ligne"><label for="colles$id">Demande d'identification pour l'affichage du programme de colle</label><input type="checkbox" id="colles$id" name="colles" value="1"$colles></p>
    <p class="ligne"><label for="cdt$id">Demande d'identification pour l'affichage du cahier de texte</label><input type="checkbox" id="cdt$id" name="cdt" value="1"$cdt></p>
    <input type="hidden" name="id" value="$id">
    <input type="hidden" name="modifie" value="">
  </form>
  </div>

FIN;
}
?>

  <script type="text/javascript">
$( function() {
  
  var n = <?php echo $n; ?>;
  $('#ajouter').click(function () {
    if ( n <= <?php echo $max; ?> )  {
      $('#ligne'+(n-1)).clone(true).attr('id','ligne'+n).insertAfter($('#ligne'+(n-1)));
      $('#ligne'+n).find('select[name="matieres['+(n-1)+']"]').attr('name','matieres['+n+']');
      $('#ligne'+n).html($('#ligne'+n).html().replace('n°'+(n-1),'n°'+n))
      $('select[name="matieres['+n+']"]').val([1]);
      n++;
    }
  });
  $('#retirer').click(function () {
    if ( n > 2 )  {
      $('#ligne'+(n-1)).remove();
      n--;
    }
  });

});
  </script>

  <script type="text/javascript" src="textarea.js.php"></script>

<?php
$mysqli->close();
// Bas de page
include('bas.php');
exit();
?>
